<?php

namespace Pinpoint\MsiChanges\Plugin\Magento\InventoryReservations\Model\ResourceModel;

use Magento\CatalogInventory\Api\StockConfigurationInterface;
use Magento\Framework\App\ResourceConnection;
use Pinpoint\MsiChanges\Plugin\Magento\InventorySales\Plugin\InventoryReservationsApi\PreventAppendReservationOnNotManageItemsInStockPlugin;

class GetReservationsQuantity extends \Magento\InventoryReservations\Model\ResourceModel\GetReservationsQuantity
{
    /**
     * @var StockConfigurationInterface
     */
    protected $stockConfiguration;

    /**
     * GetReservationsQuantity constructor.
     * @param ResourceConnection $resource
     * @param StockConfigurationInterface $stockConfiguration
     */
    public function __construct(
        ResourceConnection $resource,
        StockConfigurationInterface $stockConfiguration
    ) {
        parent::__construct($resource);

        $this->stockConfiguration = $stockConfiguration;
    }

    /**
     * @param string $sku
     * @param int $stockId
     * @return float
     */
    public function execute(string $sku, int $stockId): float
    {
        if (!(bool) $this->stockConfiguration->getDefaultConfigValue(PreventAppendReservationOnNotManageItemsInStockPlugin::ENABLE_RESERVATIONS_CONFIG)) {
            return 0;
        }

        return parent::execute($sku, $stockId);
    }
}
