<?php

namespace Pinpoint\MsiChanges\Plugin\Magento\InventorySales\Plugin\InventoryReservationsApi;

use Magento\CatalogInventory\Api\StockConfigurationInterface;
use Magento\InventoryConfigurationApi\Api\GetStockItemConfigurationInterface;
use Magento\InventoryReservationsApi\Model\AppendReservationsInterface;

/**
 * Class PreventAppendReservationOnNotManageItemsInStockPlugin
 * @package Pinpoint\MsiChanges\Plugin\Magento\InventorySales\Plugin\InventoryReservationsApi
 */
class PreventAppendReservationOnNotManageItemsInStockPlugin extends \Magento\InventorySales\Plugin\InventoryReservationsApi\PreventAppendReservationOnNotManageItemsInStockPlugin
{
    /**
     * @var string
     */
    const ENABLE_RESERVATIONS_CONFIG = 'enable_reservations';

    /**
     * @var GetStockItemConfigurationInterface
     */
    private $getStockItemConfiguration;

    /**
     * @var StockConfigurationInterface
     */
    private $stockConfiguration;

    /**
     * @param GetStockItemConfigurationInterface $getStockItemConfiguration
     * @param StockConfigurationInterface $stockConfiguration
     */
    public function __construct(
        GetStockItemConfigurationInterface $getStockItemConfiguration,
        StockConfigurationInterface $stockConfiguration
    ) {
        $this->getStockItemConfiguration = $getStockItemConfiguration;
        $this->stockConfiguration = $stockConfiguration;

        parent::__construct($getStockItemConfiguration, $stockConfiguration);
    }

    /**
     * @param AppendReservationsInterface $subject
     * @param \Closure $proceed
     * @param array $reservations
     * @throws \Magento\Framework\Exception\LocalizedException
     */
    public function aroundExecute(
        AppendReservationsInterface $subject,
        \Closure $proceed,
        array $reservations
    ) {
        if (!(bool) $this->stockConfiguration->getDefaultConfigValue(self::ENABLE_RESERVATIONS_CONFIG)) {
            return;
        }

        parent::aroundExecute($subject, $proceed, $reservations);
    }
}
